package uulm.teamname.marvelous.server.netconnector;

import org.java_websocket.WebSocket;
import org.java_websocket.handshake.ClientHandshake;
import org.java_websocket.server.WebSocketServer;
import org.tinylog.Logger;

import java.net.InetSocketAddress;

public class MarvelousServer extends WebSocketServer {
    @Override
    public void onOpen(WebSocket conn, ClientHandshake handshake) {
        Logger.info("New client connected.");
        UserManager.getInstance().connectUser(conn);
    }

    @Override
    public void onClose(WebSocket conn, int code, String reason, boolean remote) {
        Logger.info("Client disconnected.");
        UserManager.getInstance().disconnectUser(conn, remote);
    }

    @Override
    public void onMessage(WebSocket conn, String message) {
        Logger.debug("Message received: {}", message);
        UserManager.getInstance().messageReceived(conn, message);
    }

    @Override
    public void onError(WebSocket conn, Exception ex) {
        Logger.warn("WebSocket-Error occurred: {}", ex.getMessage());
    }

    @Override
    public void onStart() {
        Logger.info("MarvelousServer started on Address {}", this.getAddress().toString());
    }

    public MarvelousServer(InetSocketAddress address) {
        super(address);
    }
}
