package uulm.teamname.marvelous.server.lobby;

import org.java_websocket.WebSocket;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import uulm.teamname.marvelous.gamelibrary.messages.ParticipantType;
import uulm.teamname.marvelous.server.lobbymanager.Participant;
import uulm.teamname.marvelous.server.netconnector.Client;

import java.util.function.Consumer;

import static org.assertj.core.api.Assertions.*;
import static org.mockito.Mockito.*;

class TurnTimeoutTimerTest {
    TurnTimeoutTimer turnTimeoutTimer;

    @BeforeEach
    void beforeEach(){
        var callback = mock(Consumer.class);
        turnTimeoutTimer = new TurnTimeoutTimer(20, callback);
    }

    @Test
    void startTurnTimerTest(){
        var connection = mock(WebSocket.class);
        var participant = new Participant(new Client(connection), "lobby", ParticipantType.Spectator, false);
        assertThatIllegalStateException().describedAs("Spectators don't have TurnTime").isThrownBy(() -> turnTimeoutTimer.startTurnTimer(participant));
    }

}
